#include <stdio.h>
#include "driver.h"

char * stdlib;
char * opt = "";

main(argc, argv)
     int argc;
     char ** argv;
{
  int i;
  char * a;
  extern char * getenv();
  char * cmd;
  int status;
  char * lang;

  stdlib = getenv("CAMLLIB");
  if (stdlib == NULL) {
    fprintf(stderr, "Variable CAMLLIB is undefined.\n");
    exit(2);
  }

  lang = getenv("LANG");
  if (lang != NULL) {
    reformat(&opt, "%s -lang %s", opt, lang);
  }

  for (i = 1; i < argc; i++) {
    a = argv[i];
    if (eq(a, "-g") || eq(a, "-debug")) {
      reformat(&opt, "%s %s", opt, a);
    } else
    if (eq(a, "-I") || eq(a, "-include") || eq(a, "-O") || eq(a, "-open")) {
      reformat(&opt, "%s %s %s", opt, a, argv[++i]);
    } else
    if (eq(a, "-stdlib")) {
      stdlib = argv[++i];
    } else
    if (prefix(a, "-")) {
      fprintf(stderr, "Unknown option \"%s\", ignored\n", a);
    } else {
      format(&cmd, "-stdlib %s %s", stdlib, opt);
      terminate(a, cmd);
    }
  }
  format(&cmd, "%s\\camltop -stdlib %s %s", stdlib, stdlib, opt);
  terminate("camlrun.exe", cmd);
  return 0;
}
